package x64

import (
	"math"

	"git.akyoto.dev/cli/q/src/build/cpu"
)

// numberToRegister encodes an instruction with a register and a number parameter.
func numberToRegister(opCode8 byte, opCode32 byte, reg byte, code []byte, destination cpu.Register, number int) []byte {
	b := byte(0)

	if destination >= 8 {
		b = 1
		destination -= 8
	}

	rex := REX(1, 0, 0, b)
	modRM := ModRM(0b11, reg, byte(destination))

	if number >= math.MinInt8 && number <= math.MaxInt8 {
		return append(
			code,
			rex,
			opCode8,
			modRM,
			byte(number),
		)
	}

	return append(
		code,
		rex,
		opCode32,
		modRM,
		byte(number),
		byte(number>>8),
		byte(number>>16),
		byte(number>>24),
	)
}
